#ifndef __SKIN_H__
#define  __SKIN_H__
//#include <imaging.h>

#define SKIN_COUNT 2
#define  DECLARE_SKIN						HMODULE g_hSkin=NULL; \
											SkinDrawString fnSkinDrawString=0;
//extern IImagingFactory *g_pImgFactory;											
extern HMODULE g_hSkin;
static const TCHAR* szSkinTable[SKIN_COUNT]={
												L"CN828Job2Normal.dll" ,L"CN828Job2Black.dll"\
											};
typedef void (* SkinDrawString)(HDC m_hDC , RECT *Rect , TCHAR*String , int uFormat);

extern SkinDrawString fnSkinDrawString;
	
//#define  SET_SKIN_HANDLE(skin)   g_hSkin = LoadLibrary(szSkinTable[skin]);
#define  SET_SKIN_HANDLE(lpstrCmdLine)   GetSkinFromCmdLine(lpstrCmdLine);
#define  FREE_SKIN_HANDLE()			 FreeLibrary((HMODULE)g_hSkin);g_hSkin=NULL;
//if(g_pImgFactory) g_pImgFactory->Release(); \
//									  CoUninitialize();

inline HINSTANCE GetSkinHandle()
{
	return (HINSTANCE) g_hSkin;
}




static int g_iSkin=1;
inline HANDLE GetSkinFromCmdLine(LPTSTR lpstrCmdLine)
{
	int skin = 1 ;
//	CoInitializeEx(NULL, COINIT_MULTITHREADED);
	if(lpstrCmdLine )
		{
			LPTSTR lpSkin = wcsstr( lpstrCmdLine,L"-skin=");
			if(lpSkin)
				{
					lpSkin = lpSkin+6;
					skin = *lpSkin-'0';
					if(SKIN_COUNT<=skin) skin =0;
					g_iSkin = skin;
				}
		}
	TCHAR skinPath[64];
	wsprintf(skinPath,L"%s\\%s",SKIN_PATH,szSkinTable[skin]);
	g_hSkin = LoadLibrary(skinPath);
#ifdef UNDER_CE
	fnSkinDrawString = (SkinDrawString)GetProcAddress(g_hSkin,L"SkinDrawString");
#else
		fnSkinDrawString = (SkinDrawString)GetProcAddress(g_hSkin,"SkinDrawString");
#endif
		g_iSkin = skin;
	return g_hSkin;
		
}

inline HANDLE ChangeSkin()
{
	int skin = (g_iSkin==0)?1:0;
	if(skin<0 || skin>1) return g_hSkin;
	TCHAR skinPath[64];
	wsprintf(skinPath,L"%s\\%s",SKIN_PATH,szSkinTable[skin]);
	if(g_hSkin)  FreeLibrary(g_hSkin);
	g_hSkin = LoadLibrary(skinPath);
#ifdef UNDER_CE
	fnSkinDrawString = (SkinDrawString)GetProcAddress(g_hSkin,L"SkinDrawString");
#else
		fnSkinDrawString = (SkinDrawString)GetProcAddress(g_hSkin,"SkinDrawString");
#endif
	g_iSkin = skin;
	return g_hSkin;

}

//#undef  LoadBitmap 
//#define LoadBitmapW LoadMyBitmapW

#endif