#pragma once

template <class T> class SingleToneHold
{
	typedef T SingleToneType;

protected: 
	SingleToneHold() 
	{}

public:	
	~SingleToneHold() 
	{ 
		m_psingleTone = NULL; 
	}

public:
	static SingleToneType & GetInstance() 
	{
		if (NULL == m_psingleTone) 
		{
			static SingleToneType theobj;

			m_psingleTone = &theobj;
		}
		return *m_psingleTone;
	}

private:
	
	static SingleToneType * m_psingleTone;
};
